//simple button GET server code to control relay with arduino pins
//for use with Arduino IDE 1.0
//open serial monitor to see what the arduino receives
//use the \ slash to escape the " in the html
//for use with Wiznet W5100 based ethernet shields
 
#include <SPI.h>
#include <Ethernet.h>
 
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //physical mac address
byte ip[] = { 192, 168, 1, 97 }; // ip
byte gateway[] = { 192, 168, 1, 1 }; // gateway
byte subnet[] = { 255, 255, 255, 0 }; //subnet mask
EthernetServer server(80); //server port
 
String readString;
 
//////////////////////
 
int relayPin1 = 4;                 // relay IN1 connected to digital pin 4
int relayPin2 = 5;                 // relay IN2 connected to digital pin 5
int relayPin3 = 6;                 // relay IN3 connected to digital pin 6
int mvPin1 = 7;                    // Media Vault power switch connected to digital pin 7
int mvPin2 = 8;                    // Media Vault LED connected to digital pin 8
int relayPin8 = 9;                 // relay IN8 connected to digital pin 9 for PC power switch
int pcPin2 = 11;                   // PC LED connected to digital pin 11
 
void setup(){
digitalWrite(relayPin1, HIGH);        // Prevents relays from starting up engaged
digitalWrite(relayPin2, HIGH);        // Prevents relays from starting up engaged
digitalWrite(relayPin3, HIGH);        // Prevents relays from starting up engaged
digitalWrite(mvPin1, LOW);            // Starts with Media Vault powered down
digitalWrite(relayPin8, HIGH);        // Prevents relays from starting up engaged. Starts without triggering change to PC power
  
 
  pinMode(4, OUTPUT); //pin selected to control livingroom ceiling fan
  pinMode(5, OUTPUT); //pin selected to control master bedroom light
  pinMode(6, OUTPUT); //pin selected to control master bedroom ceiling fan
  pinMode(7, OUTPUT); //pin selected to control Media Vault power
  pinMode(8, INPUT);  //pin selected to monitor Media Vault power status, not necessary to declare an input
  pinMode(9, OUTPUT); //pin selected to control PC power
  pinMode(11, INPUT); //pin selected to monitor PC power status, not necessary to declare an input
  //start Ethernet
  Ethernet.begin(mac, ip, gateway, subnet);
  server.begin();
  //enable serial data print
  Serial.begin(9600);
  Serial.println("network light/fan/media vault/pc control server v15a"); // so I see in serial monitor what is loaded
}
 
void loop(){
  // Create a client connection
  EthernetClient client = server.available();
  if (client) {
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
 
        //read char by char HTTP request
        if (readString.length() < 100) {
 
          //store characters to string
          readString += c;
          //Serial.print(c);
        }
 
        //if HTTP request has ended
        if (c == '\n') {
 
          ///////////////
          Serial.println(readString); //print to serial monitor for debugging
 
          client.println("HTTP/1.1 200 OK"); //send new page
          client.println("Content-Type: text/html");
          client.println();
 
          client.println("<HTML>");
          client.println("<HEAD>");
          client.println("<meta name='apple-mobile-web-app-capable' content='yes' />");
          client.println("<meta name='apple-mobile-web-app-status-bar-style' content='black-translucent' />");
          client.println("<link rel='stylesheet' type='text/css' href='http://homeautocss.net84.net/a.css' />");
          client.println("<TITLE>Arduino Home Automation</TITLE>");
          client.println("</HEAD>");
          client.println("<BODY>");
          client.println("<H1>Arduino Home Automation</H1>");
          client.println("<hr />");
         
          client.println("<H2>Living Room</H2>");
          client.println("<br />");
 if (digitalRead(4) >0){
    client.print("Fan is <font color='red'><b>OFF</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device1on\"\">Fan On</a><br /><br /><br />");
  }
  else{
    client.print("Fan is <font color='green'><b>ON</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device1off\"\">Fan Off</a><br /><br /><br />");
  }
          client.println("<a href=\"http://192.168.1.97/\"\">Refresh Page</a><br />");
          client.println("<br />");
          client.println("<hr />");
          client.println("<H2>Master Bedroom</H2>");
          client.println("<br />");
  if (digitalRead(5) >0){
    client.print("Light is <font color='red'><b>OFF</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device2on\"\">Light On</a><br /><br /><br />");
  }
  else{
    client.print("Light is <font color='green'><b>ON</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device2off\"\">Light Off</a><br /><br /><br />");
  }
  if (digitalRead(6) >0){
    client.print("Fan is <font color='red'><b>OFF</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device3on\"\">Fan On</a><br /><br /><br />");
  }
  else{
    client.print("Fan is <font color='green'><b>ON</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?device3off\"\">Fan Off</a><br /><br /><br />");
  }
          client.println("<a href=\"http://192.168.1.97/\"\">Refresh Page</a><br />");
          client.println("<br />");
          client.println("<hr />");
          client.println("<H2>Office</H2>");
          client.println("<br />");
  if (digitalRead(8) >0){
    client.print("Media Vault is <font color='green'><b>ON</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?mvoff\"\">Media Vault Off</a><br /><br />");
  }
  else{
    client.print("Media Vault is <font color='red'><b>OFF</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?mvon\"\">Media Vault On</a><br /><br />");
  }
  client.println("<br />");
  if (digitalRead(11) >0){
    client.print("PC is <font color='green'><b>ON</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?pcoff\"\">PC Suspend</a><br /><br /><br />");
          client.println("<a href=\"http://192.168.1.97/?pcreset\"\">PC Reset</a><br /><br /><br />");
          client.println("<a href=\"http://192.168.1.97/\"\">Refresh Page</a><br />");
  }
  else{
    client.print("PC is <font color='red'><b>OFF</b></font><br />");
          client.println("<br />");
          client.println("<a href=\"http://192.168.1.97/?pcon\"\">PC Wake</a><br /><br /><br />");
          client.println("<a href=\"http://192.168.1.97/\"\">Refresh Page</a><br />");
  }
          client.println("<br />");
          client.println("<hr />");
          client.println("<br />");
          
          client.println("<b>Arduino MEGA 2560 R3</b><br />");
          client.println("<b>Arduino Ethernet Shield R3</b><br />");
          client.println("<b>Sainsmart 8-ch 5v Relay Board</b><br />");
          client.println("<b>control_lights_fans_and_computers_v15a.ino</b><br />");
          client.println("<b>Uploaded June 2, 2014 from WinBook-J4/Pinguy OS 12.04</b><br />");
 
          client.println("</BODY>");
          client.println("</HTML>");
 
          delay(1);
          //stopping client
          client.stop();
 
          ///////////////////// control arduino pin 4
          if(readString.indexOf("?device1on") >0)//checks header string for on request
          {
            digitalWrite(4, LOW);    // set pin 4 low
            Serial.println("Living Room Fan On");
            Serial.println("----------");
            Serial.println();
          }
          else{
          if(readString.indexOf("?device1off") >0)//checks header string for off request
          {
            digitalWrite(4, HIGH);    // set pin 4 high
            Serial.println("Living Room Fan Off");
            Serial.println("----------");
            Serial.println();
          }
          }

          ///////////////////// control arduino pin 5
          if(readString.indexOf("?device2on") >0)//checks header string for on request
          {
            digitalWrite(5, LOW);    // set pin 5 low
            Serial.println("Master Bedroom Light On");
            Serial.println("----------");
            Serial.println();
          }
          else{
          if(readString.indexOf("?device2off") >0)//checks header string for off request
          {
            digitalWrite(5, HIGH);    // set pin 5 high
            Serial.println("Master Bedroom Light Off");
            Serial.println("----------");
            Serial.println();
          }
          }
 
          ///////////////////// control arduino pin 6
          if(readString.indexOf("?device3on") >0)//checks header string for on request
          {
            digitalWrite(6, LOW);    // set pin 6 low
            Serial.println("Master Bedroom Fan On");
            Serial.println("----------");
            Serial.println();
          }
          else{
          if(readString.indexOf("?device3off") >0)//checks header string for off request
          {
            digitalWrite(6, HIGH);    // set pin 6 high
            Serial.println("Master Bedroom Fan Off");
            Serial.println("----------");
            Serial.println();
          }
          }
 
          ///////////////////// control arduino pin 7
          if(readString.indexOf("?mvon") >0)//checks header string for on request
          {
            digitalWrite(7, HIGH);    // set pin 7 high so micro relay can trigger Media Vault to power up
            Serial.println("Media Vault powering up");
            Serial.println("----------");
            Serial.println();
          }
          else{
          if(readString.indexOf("?mvoff") >0)//checks header string for off request
          {
            digitalWrite(7, LOW);    // set pin 7 low so micro relay can trigger Media Vault to power down
            Serial.println("Media Vault powering down");
            Serial.println("----------");
            Serial.println();
          }
          }
 
          ///////////////////// control arduino pin 9
          if(readString.indexOf("?pcon") >0)//checks header string for on request
          {
            digitalWrite(9, LOW);    // set pin 9 low **since now it is connected to Sainsmart relay**
            delay(250);                // wait 250 ms
            digitalWrite(9, HIGH);     // set pin 9 high (this is to mimic momentary power switch on PC)
            Serial.println("PC waking up");
            Serial.println("----------");
            Serial.println();
          }
          else{
          if(readString.indexOf("?pcoff") >0)//checks header string for off request
          {
            digitalWrite(9, LOW);    // set pin 9 low **since now it is connected to Sainsmart relay**
            delay(250);                // wait 250 ms
            digitalWrite(9, HIGH);     // set pin 9 high (this is to mimic momentary power switch on PC)
            Serial.println("PC hibernating");
            Serial.println("----------");
            Serial.println();
          }else{
          if(readString.indexOf("?pcreset") >0)//checks header string for reset request
          {
            digitalWrite(9, LOW);    // set pin 9 low **since now it is connected to Sainsmart relay**
            delay(4000);              // wait 4 seconds to force PC to power off/reset
            digitalWrite(9, HIGH);     // set pin 9 high (this is to mimic momentary power switch on PC)
            delay(2000);              // wait 2 seconds
            digitalWrite(9, LOW);    // set pin 9 low to restart
            delay(50);                // wait 50 ms
            digitalWrite(9, HIGH);     // set pin 9 high (this is to mimic momentary power switch on PC)
            Serial.println("PC resetting");
            Serial.println("----------");
            Serial.println();
          }
          }
          }
          
          //clearing string for next read
          readString="";
          
        }
      }
    }
  }
}
